/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lambdaPrzyjmujeListe;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 *
 * @author andrzej
 */
public class Odpal {

    private static void przetwarzanie(List<Integer> lista, PrzetwarzanieListy pl) {
        List<Integer> wyjscie = pl.przetworz(lista);
        for (Integer i : wyjscie) {
            System.out.println(i);
        }
    }

    public static void main(String args[]) {
        List<Integer> lista = Arrays.asList(1, 2, 3, 4, 5);
        przetwarzanie(lista, new PrzetwarzanieListy() {
            @Override
            public List<Integer> przetworz(List<Integer> lista) {
                List<Integer> out = new ArrayList<>();
                for (Integer i : lista) {
                    out.add(i * 2);
                }
                return out;
            }
        });

        przetwarzanie(lista, v -> {
            List<Integer> out = new ArrayList<>();
            for (Integer i : v) {
                out.add(i * 2);
            }
            return out;
        }
        );
       

    }
}
